#version 410

#define MAX_LIGHTS 3

#pragma include "p3d_in.glsl"
#pragma include "p3d_uniform.glsl"

uniform int u_NumberOfLights;

// Outputs to fragment shader
out vec4 vertColor;
out vec4 vertPosition;
out vec3 vertNormal;
out vec3 binormal;
out vec3 tangent;
out vec4 vertInShadowSpaces[MAX_LIGHTS];
out vec2 vertMultiTexCoord0;

void main() {
    vertPosition = p3d_Vertex;
    vertColor = p3d_Color;
//    vertColor = vec4(1.0, 0.0, 0.0, 1.0);
    vertPosition = p3d_ModelViewMatrix * vertPosition;
    gl_Position = p3d_ProjectionMatrix * vertPosition;
    for (int i = 0; i < u_NumberOfLights; ++i) {
        vertInShadowSpaces[i] = p3d_LightSource[i].shadowViewMatrix * vertPosition;
    }
    vertMultiTexCoord0 = p3d_MultiTexCoord0;
    vertNormal = normalize(p3d_NormalMatrix * p3d_Normal);
    tangent = normalize(p3d_NormalMatrix * p3d_Tangent);
    binormal = cross(vertNormal, tangent);
}
